/*
GoFans Client Copyright (C) 2010 Robert Grning (GoFans)
This program comes with ABSOLUTELY NO WARRANTY.
This is free software, and you are welcome to redistribute it under certain conditions. 
<http://www.gnu.org/licenses/>
*/
//class
function DesignerImporter(){
 
}
 
//public
DesignerImporter.prototype.Import = function(xml){
 
 return this.private_GetDesignerHandler(xml);
}
 
//private
DesignerImporter.prototype.private_ReadNode = function(node, name){
 
 var childNode = null;
 
 if(this.private_ReadNodes(node, name).length > 0)
 {
  childNode = this.private_ReadNodes(node, name)[0];
 }
 
 return childNode;
}
 
//private
DesignerImporter.prototype.private_ReadNodes = function(node, name){
 
 var childNodes = new Array();
 
 for (var i  = 0; i < node.childNodes.length; i++)
 {
  if(node.childNodes[i].tagName == name)  
  {
   childNodes[childNodes.length] = node.childNodes[i];
  }
 }
  
 return childNodes;
}

//private
DesignerImporter.prototype.private_GetDesignerHandler = function(node){
 
 var designerHandler = new DesignerHandler();
 
 var nodeIndex = this.private_ReadNode(node, "index"); 
 var nodesDesigner = this.private_ReadNodes(nodeIndex, "designer"); 
 
 for (var i = 0; i < nodesDesigner.length; i++)
 {
  designerHandler.AddDesigner(this.private_ReadDesigner(nodeIndex, i));
 }
 
 return designerHandler;
}

//private
DesignerImporter.prototype.private_ReadDesigner = function(node, index){
 
 var designer = null;
 
 if(this.private_ReadNodes(node, "designer") != null)
 {
  designer = new Designer();
  var nodeDesigner = this.private_ReadNodes(node, "designer")[index];
  designer.Name = nodeDesigner.attributes.getNamedItem("name").value;
 
  var nodesDesign = this.private_ReadNodes(nodeDesigner, "design"); 
  
  for (var i = 0; i < nodesDesign.length; i++)
  {
   designer.AddDesign(this.private_ReadDesign(nodeDesigner, i));
  }
 }
 
 return designer;
}

//private
DesignerImporter.prototype.private_ReadDesign = function(node, index){
 
 var design = null;
 
 if(this.private_ReadNodes(node, "design") != null)
 {
  design = new Design();
  var nodeDesign = this.private_ReadNodes(node, "design")[index];
  design.Name = nodeDesign.attributes.getNamedItem("name").value;
  design.Path = nodeDesign.attributes.getNamedItem("path").value;
 
  var nodesStone = this.private_ReadNodes(nodeDesign, "stone"); 
  
  for (var i = 0; i < nodesStone.length; i++)
  {
   design.AddStone(this.private_ReadStone(nodeDesign, i));
  }
 }
 
 return design;
}

//private
DesignerImporter.prototype.private_ReadStone = function(node, index){
 
 var stone = null;
 
 if(this.private_ReadNodes(node, "stone") != null)
 {
  stone = new Stone();
  var nodeStone = this.private_ReadNodes(node, "stone")[index];
  stone.Color = nodeStone.attributes.getNamedItem("color").value;
  stone.Name = nodeStone.attributes.getNamedItem("name").value; 
 }
 
 return stone;
}
