/*
GoFans Client Copyright (C) 2010 Robert Grning (GoFans)
This program comes with ABSOLUTELY NO WARRANTY.
This is free software, and you are welcome to redistribute it under certain conditions. 
<http://www.gnu.org/licenses/>
*/
//class
BitBoard = function(size){
	//public
	this.Fields = new Array();

	//private
	//Auxiliary variables
	this.BitBoardOrientation = null;
	this.Chain = new Chain();

	this.private_Create(parseInt(size));
}

//public
BitBoard.prototype.GetCopy = function(){

	var copy = new BitBoard(this.Fields.length);
	
	copy.Or(this);

	return copy;
}

//public
BitBoard.prototype.GetValue = function(x, y){

	return this.Fields[x][y];
}

//public
BitBoard.prototype.SetValues = function(chain, value){

	for(var i = 0; i < chain.Elements.length; i++)
	{
		this.SetValue(chain.Elements[i].X, chain.Elements[i].Y, value);
	}	
}

//public
BitBoard.prototype.SetValue = function(x, y, value){

	return this.Fields[x][y] = value;
}

//private
BitBoard.prototype.private_Create = function(size){
 
	this.Fields = new Array(size);

	for (var x = 0; x < this.Fields.length; x++)
	{
		this.Fields[x] = new Array(size);
		for (var y = 0; y < this.Fields[x].length; y++)
		{
			this.Fields[x][y] = false;
		}
	}
}

//public
BitBoard.prototype.Clear = function(){
  
	for (var x = 0; x < this.Fields.length; x++)
	{
		for (var y = 0; y < this.Fields[x].length; y++)
		{
			this.Fields[x][y] = false;
		}
	}
}

//public
BitBoard.prototype.Or = function(bitBoard){
  
	for (var x = 0; x < this.Fields.length; x++)
	{
		for (var y = 0; y < this.Fields[x].length; y++)
		{
			this.Fields[x][y] = this.Fields[x][y] || bitBoard.Fields[x][y];
		}
	}
}

//public
BitBoard.prototype.Not = function(){
  
	for (var x = 0; x < this.Fields.length; x++)
	{
		for (var y = 0; y < this.Fields[x].length; y++)
		{
			this.Fields[x][y] = ! this.Fields[x][y];
		}
	}
}

//public
BitBoard.prototype.GetBorder = function(x, y){
 
	//set variables
	this.BitBoardOrientation = new BitBoard(this.Fields.length);
	this.Chain = new Chain();
	var border = new Chain();

	//calculate
	this.private_GetBorder(x, y, this.Fields[x][y]);
	border = this.Chain;

	//clear variables
	this.BitBoardOrientation = null;
	this.Chain = null;

	return border; 
}

//public
BitBoard.prototype.GetChain = function(x, y){
 
	//set variables
	this.BitBoardOrientation = new BitBoard(this.Fields.length);
	this.Chain = new Chain();
	var chain = new Chain();

	//calculate
	this.private_GetChain(x, y, this.Fields[x][y]);
	chain = this.Chain;

	//clear variables
	this.BitBoardOrientation = null;
	this.Chain = null;

	return chain; 
}

//private
BitBoard.prototype.private_GetBorder = function(x, y, valueToCheck){
 
	if(this.BitBoardOrientation.Fields[x][y] == false)
	{
		this.BitBoardOrientation.SetValue(x, y, true); 

		if(this.Fields[x][y] == valueToCheck)
		{
			//go to north
			if(this.Fields[x].length > (y + 1))
			{
				this.private_GetBorder(x, y + 1, valueToCheck);
			}

			//go to east
			if(this.Fields.length > (x + 1))
			{
				this.private_GetBorder(x + 1, y, valueToCheck);
			}

			//go to south
			if(0 <= (y - 1))
			{
				this.private_GetBorder(x, y - 1, valueToCheck);
			}

			//go to west
			if(0 <= (x - 1))
			{
				this.private_GetBorder(x - 1, y, valueToCheck);
			}   
		}
		else
		{
			this.Chain.Add(new Position(x, y));
		}   
	}
}

//private
BitBoard.prototype.private_GetChain = function(x, y, valueToCheck){
 
	if(this.BitBoardOrientation.Fields[x][y] == false)
	{  
		this.BitBoardOrientation.SetValue(x, y, true);  

		if(this.Fields[x][y] == valueToCheck)
		{
			//found allied stone
			this.Chain.Add(new Position(x, y));

			//go to north
			if(this.Fields[x].length > (y + 1))
			{
				this.private_GetChain(x, y + 1, valueToCheck);
			}

			//go to east
			if(this.Fields.length > (x + 1))
			{
				this.private_GetChain(x + 1, y, valueToCheck);
			}

			//go to south
			if(0 <= (y - 1))
			{
				this.private_GetChain(x, y - 1, valueToCheck);
			}

			//go to west
			if(0 <= (x - 1))
			{
				this.private_GetChain(x - 1, y, valueToCheck);
			}   
		}
	}
}