/*
GoFans Client Copyright (C) 2010 Robert Grning (GoFans)
This program comes with ABSOLUTELY NO WARRANTY.
This is free software, and you are welcome to redistribute it under certain conditions. 
<http://www.gnu.org/licenses/>
*/
//class
Igo = function(){
    //public
	this.Rule = new Rule();
	this.Rule.Name = "igo";
    this.Board = null;
	this.Server = "";
	this.Date = new Date();
	this.Computation = null;
	this.Players = new Array();
	this.Moves = new Array();
	this.CurrentMove = null;
	
	//private
	this.private_BitBoardAllied = null;
	this.private_BitBoardOpponents = null;
	this.private_BitBoardLiberties = null;
}

//public
Igo.prototype.SetTerritory = function(){  

	for (var i = 0; i < this.Players.length; i++)
	{
		this.Players[i].Territory = this.GetTerritory(this.Players[i].Id).Elements.length;
	}	
}

//public
Igo.prototype.GetTerritory = function(playerId){  

	var territory = new Chain();
	this.private_BitBoardAllied = new BitBoard(this.Board.Size);
	this.private_BitBoardOpponents = new BitBoard(this.Board.Size);
	this.private_BitBoardLiberties = new BitBoard(this.Board.Size);

	//set
	this.private_BitBoardAllied = this.Players[playerId].BitBoard;

	for (var i = 0; i < this.Players.length; i++)
	{
		if(this.Players[i].Id != playerId)
		{
			this.private_BitBoardOpponents.Or(this.Players[i].BitBoard);
		}
	}

	this.private_BitBoardLiberties.Or(this.private_BitBoardAllied);
	this.private_BitBoardLiberties.Or(this.private_BitBoardOpponents);
	var bitBoardOrientation = this.private_BitBoardLiberties.GetCopy();
	this.private_BitBoardLiberties.Not();
	
	for(x = 0; x < this.Board.Size; x++)
	{
		for(y = 0; y < this.Board.Size; y++)
		{
			if(bitBoardOrientation.GetValue(x, y) == false)
			{				
				if(this.private_BitBoardLiberties.GetValue(x, y) == true)
				{
					var chain = this.private_BitBoardLiberties.GetChain(x, y);
					var border = this.private_BitBoardLiberties.GetBorder(x, y);
					var isBorderOfOnePlayer = true;
					
					for(var i = 0; i < border.Elements.length; i++)
					{
						if(this.private_BitBoardAllied.GetValue(border.Elements[i].X, border.Elements[i].Y) == false)
						{
							isBorderOfOnePlayer = false;
							break;
						}
					}
					
					if(isBorderOfOnePlayer == true)
					{
						for(var i = 0; i < chain.Elements.length; i++)
						{						
							territory.Add(chain.Elements[i]);
						}
					}	

					bitBoardOrientation.SetValues(chain, true);
				}
			}
		}
	}
	
	if(this.Computation.Type == "chinese")
	{		
		for(x = 0; x < this.Board.Size; x++)
		{
			for(y = 0; y < this.Board.Size; y++)
			{
				if(this.private_BitBoardAllied.GetValue(x, y) == true)
				{
					territory.Add(new Position(x, y));
				}
			}
		}
	}
			
	return territory;
}

//public
Igo.prototype.Capitulate = function(){  

	var message = 413;
	
	var capitulation = new Capitulation();
	capitulation.PlayerId = this.GetCurrentPlayerId();
	
	this.Players[capitulation.PlayerId].HasCapitulated = true;
		
	if(this.IsOneMoreMoveAllowed() == true)
	{	
		message = 213;
		
		if(this.CurrentMove == null)
		{
			this.Moves[this.Moves.length] = capitulation;
		}
		else
		{
			this.CurrentMove.Moves[this.CurrentMove.Moves.length] = capitulation;
			this.CurrentMove.Moves[this.CurrentMove.Moves.length - 1].Parent = this.CurrentMove;
		}
	}
		
	return message;
}

//public
Igo.prototype.Pass = function(){  

	var message = 402;
	
	var pass = new Pass();
	pass.PlayerId = this.GetCurrentPlayerId();
		
	if(this.IsOneMoreMoveAllowed() == true)
	{	
		message = 202;
		
		if(this.CurrentMove == null)
		{
			this.Moves[this.Moves.length] = pass;
		}
		else
		{
			this.CurrentMove.Moves[this.CurrentMove.Moves.length] = pass;
			this.CurrentMove.Moves[this.CurrentMove.Moves.length - 1].Parent = this.CurrentMove;
		}
	}
		
	return message;
}

//public
Igo.prototype.GetCurrentPlayerId = function(){  

	var currentPlayerId = 0;
	
	if(this.CurrentMove != null)
	{		
		if ((this.CurrentMove.PlayerId + 1) < this.Players.length)
		{
			currentPlayerId = this.CurrentMove.PlayerId + 1;
		}
	}
	
	return currentPlayerId;
}

//public
Igo.prototype.SetDefaultHandicap = function(){  
	
	var indexMax;
	var indexHalf = (this.Board.Size - 1) / 2;
	var indexMin;

	if(this.Board.Size == 9)
	{
		indexMax = (this.Board.Size - 1) - 2;
		indexMin = 2;
	}
	else if(this.Board.Size == 13 || this.Board.Size == 19)
	{
		indexMax = (this.Board.Size - 1) - 3;
		indexMin = 3;
	}
	
	for (var i = 1; i <= this.Players[0].Handicap; i++)
	{
		var positioning = new Positioning();
		positioning.PlayerId = 0;
		
		switch (i)
		{
			case 1:
			{
				positioning.X = indexMax;
				positioning.Y = indexMax;
				break;
			}
			case 2:
			{
				positioning.X = indexMin;
				positioning.Y = indexMin;
				break;
			}
			case 3:
			{
				positioning.X = indexMax;
				positioning.Y = indexMin;
				break;
			}
			case 4:
			{
				positioning.X = indexMin;
				positioning.Y = indexMax;
				break;
			}
			case 5:
			{
				if(this.Players[0].Handicap == 5)
				{
					positioning.X = indexHalf;
					positioning.Y = indexHalf;
				}
				else
				{
					positioning.X = indexMax;
					positioning.Y = indexHalf;
				}
				break;
			}
			case 6:
			{
				positioning.X = indexMin;
				positioning.Y = indexHalf;		
				break;					
			}
			case 7:
			{
				if(this.Players[0].Handicap == 7)
				{
					positioning.X = indexHalf;
					positioning.Y = indexHalf;
				}
				else
				{
					positioning.X = indexHalf;
					positioning.Y = indexMin;
				}
				break;
			}
			case 8:
			{
				positioning.X = indexHalf;
				positioning.Y = indexMax;
				break;					
			}
			case 9:
			{
				positioning.X = indexHalf;
				positioning.Y = indexHalf;		
				break;
			}
		}
		
		if(this.CurrentMove == null)
		{
			this.Moves[this.Moves.length] = positioning;
		}
		else
		{
			this.CurrentMove.Moves[this.CurrentMove.Moves.length] = positioning;
			this.CurrentMove.Moves[this.CurrentMove.Moves.length - 1].Parent = this.CurrentMove;
		}
		
		this.GoToNext(0);			
	}
}

//public
Igo.prototype.ClearKifu = function(){  

	this.Moves = new Array();
	this.CurrentMove = null;
	
	this.private_BitBoardAllied = null;
	this.private_BitBoardOpponents = null;
	this.private_BitBoardLiberties = null;
}

//public
Igo.prototype.GoToCleanBoard = function(){  

	var message = 208;
	
	for (var i = 0; i < this.Players.length; i++)
	{
		this.Players[i].Territory = 0;
		this.Players[i].Prisoners = 0;
		this.Players[i].BitBoard.Clear();
	}
	
	this.CurrentMove = null;
	
	return message;
}

//public
Igo.prototype.GoToPrevious = function(){  

	var message = 208; 

	if(this.CurrentMove != null)
	{ 
		if(this.CurrentMove.Type == "positioning")
		{
			this.Players[this.CurrentMove.PlayerId].BitBoard.Fields[this.CurrentMove.X][this.CurrentMove.Y] = false;

			for (var i = 0; i < this.CurrentMove.Prisoners.length; i++)
			{
				this.Players[this.CurrentMove.Prisoners[i].PlayerId].BitBoard.Fields[this.CurrentMove.Prisoners[i].X][this.CurrentMove.Prisoners[i].Y] = true;
			}
			
			this.Players[this.CurrentMove.PlayerId].Prisoners -= this.CurrentMove.Prisoners.length;			
		}
		else if(this.CurrentMove.Type == "pass")
		{
			for (var i = 0; i < this.CurrentMove.Prisoners.length; i++)
			{
				this.Players[this.CurrentMove.Prisoners[i].PlayerId].BitBoard.Fields[this.CurrentMove.Prisoners[i].X][this.CurrentMove.Prisoners[i].Y] = true;
			}			

			for(var i = 0; i < this.CurrentMove.Prisoners.length; i++)
			{
				if(this.CurrentMove.Prisoners[i].PlayerId != this.CurrentMove.PlayerId)
				{
					this.Players[this.CurrentMove.PlayerId].Prisoners--;
				}
				else
				{
					//ToDo
					if(this.CurrentMove.PlayerId == 0)
					{
						this.Players[1].Prisoners--;
					}
					else
					{
						this.Players[0].Prisoners--;
					}
				}
			}	
		}

		if(this.CurrentMove.Parent != null)
		{
			this.CurrentMove = this.CurrentMove.Parent;
			
			if(this.CurrentMove.Type == "positioning")
			{
				message = 201;
			}
			else if (this.CurrentMove.Type == "pass")
			{
				message = 203;
			}
			else if (this.CurrentMove.Type == "capitulation")
			{
				message = 214;
			}
		}
		else
		{
			this.CurrentMove = null;
		}
	} 

	return message;
}

//public
Igo.prototype.GoToNext = function(childIndex){  

	var message = 209;	

	if(this.CurrentMove == null && this.Moves.length > 0)
	{
		this.CurrentMove = this.Moves[childIndex];
		message = 200;
	}
	else if(this.CurrentMove != null && (this.CurrentMove.Type == "positioning" || this.CurrentMove.Type == "pass") && this.CurrentMove.Moves.length > 0)
	{
		this.CurrentMove = this.CurrentMove.Moves[childIndex];
		message = 200;
	}

	if(message == 200)
	{
		if(this.CurrentMove.Type == "pass")
		{
			for (var i = 0; i < this.CurrentMove.Prisoners.length; i++)
			{
				this.Players[this.CurrentMove.Prisoners[i].PlayerId].BitBoard.Fields[this.CurrentMove.Prisoners[i].X][this.CurrentMove.Prisoners[i].Y] = false;
			}

			for(var i = 0; i < this.CurrentMove.Prisoners.length; i++)
			{
				if(this.CurrentMove.Prisoners[i].PlayerId != this.CurrentMove.PlayerId)
				{
					this.Players[this.CurrentMove.PlayerId].Prisoners++;
				}
				else
				{
					//ToDo
					if(this.CurrentMove.PlayerId == 0)
					{
						this.Players[1].Prisoners++;
					}
					else
					{
						this.Players[0].Prisoners++;
					}
				}
			}
			
			message = 202;
		}
		else if(this.CurrentMove.Type == "capitulation")
		{
			message = 213;
		}
		else if(this.CurrentMove.Type == "positioning")
		{
			this.Players[this.CurrentMove.PlayerId].BitBoard.Fields[this.CurrentMove.X][this.CurrentMove.Y] = true;

			for (var i = 0; i < this.CurrentMove.Prisoners.length; i++)
			{
				this.Players[this.CurrentMove.Prisoners[i].PlayerId].BitBoard.Fields[this.CurrentMove.Prisoners[i].X][this.CurrentMove.Prisoners[i].Y] = false;
			}

			this.Players[this.CurrentMove.PlayerId].Prisoners += this.CurrentMove.Prisoners.length;
		}
	}

	return message;
}

//public
Igo.prototype.Position = function(x, y){  

	var message = 400;
	
	if(this.IsOneMoreMoveAllowed() == true)
	{	
		if(this.IsOccupied(x, y) == true)
		{
			message = 404;
		}
		else
		{		
			if(this.IsSuicide(x, y) == false)
			{
				message = 205;
				var positioning = new Positioning();
				positioning.PlayerId = this.GetCurrentPlayerId();
				positioning.X = x;	
				positioning.Y = y;	
				positioning.Prisoners = this.private_GetPrisoners(x, y);
				
				if(positioning.Prisoners.length > 0)
				{
					message = 204;
				}

				if(this.CurrentMove == null)
				{
					this.Moves[this.Moves.length] = positioning;
				}
				else
				{
					this.CurrentMove.Moves[this.CurrentMove.Moves.length] = positioning;
					this.CurrentMove.Moves[this.CurrentMove.Moves.length - 1].Parent = this.CurrentMove;
				}
			}
		}
	}
	
	return message;
}

//public
Igo.prototype.IsOccupied = function(x, y){  

	var isOccupied = false;
	
	for(var i = 0; i < this.Players.length; i++)
	{
		if(this.Players[i].BitBoard.GetValue(x, y) == true)
		{
			isOccupied = true;
			break;
		}
	}
	
	
	return isOccupied;
}

//public
Igo.prototype.IsSuicide = function(x, y){  

	var isSuicide = true;
	
	this.private_BitBoardAllied = new BitBoard(this.Board.Size);
	this.private_BitBoardOpponents = new BitBoard(this.Board.Size);
	this.private_BitBoardLiberties = new BitBoard(this.Board.Size);

	//set
	this.private_BitBoardAllied = this.Players[this.GetCurrentPlayerId()].BitBoard;

	for (var i = 0; i < this.Players.length; i++)
	{
		if(this.Players[i].Id != this.GetCurrentPlayerId())
		{
			this.private_BitBoardOpponents.Or(this.Players[i].BitBoard);
		}
	}

	this.private_BitBoardLiberties.Or(this.private_BitBoardAllied);
	this.private_BitBoardLiberties.Or(this.private_BitBoardOpponents);
	this.private_BitBoardLiberties.Not();	
		
	//check if opponent chains can be captured
	//go to north
	if(this.Board.Size > (y + 1) && this.private_BitBoardOpponents.Fields[x][y + 1] == true)
	{
		var libertiesOpponents = this.private_GetLibertiesOpponents(x, y + 1, 2); 

		if(libertiesOpponents.Elements.length == 1)
		{   
			isSuicide = false;
		}
	}

	//go to east
	if(isSuicide == true && this.Board.Size > (x + 1) && this.private_BitBoardOpponents.Fields[x + 1][y] == true)
	{
		var libertiesOpponents = this.private_GetLibertiesOpponents(x + 1, y, 2); 

		if(libertiesOpponents.Elements.length == 1)
		{   
			isSuicide = false;
		}
	}

	//go to south
	if(isSuicide == true && 0 <= (y - 1) && this.private_BitBoardOpponents.Fields[x][y - 1] == true)
	{
		var libertiesOpponents = this.private_GetLibertiesOpponents(x, y - 1, 2); 

		if(libertiesOpponents.Elements.length == 1)
		{   
			isSuicide = false;
		}
	}

	//go to west
	if(isSuicide == true && 0 <= (x - 1) && this.private_BitBoardOpponents.Fields[x - 1][y] == true)
	{
		var libertiesOpponents = this.private_GetLibertiesOpponents(x - 1, y, 2); 

		if(libertiesOpponents.Elements.length == 1)
		{   
			isSuicide = false;
		}
	}  

	if(isSuicide == true)
	{
		//set stone to test if this move is allowed
		this.private_BitBoardAllied.Fields[x][y] = true;  

		//ToDo: stop when one has been found
		var libertiesAllied = this.private_GetLibertiesAllied(x, y, 1); 

		if(libertiesAllied.Elements.length == 1)
		{   
			isSuicide = false;
		}

		//reset stone that was tested to be allowed
		this.private_BitBoardAllied.Fields[x][y] = false; 
	}	
	
	return isSuicide;
}

//private
Igo.prototype.private_GetLibertiesOpponents = function(x, y, numberMin){  

	var liberties = new Chain();  
  
	var border = this.private_BitBoardOpponents.GetBorder(x, y);
   
	for (var i = 0; i < border.Elements.length; i++)
	{
		if(this.private_BitBoardLiberties.Fields[border.Elements[i].X][border.Elements[i].Y] == true)
		{
			if(liberties.Elements.length == numberMin)
			{
				break;
			}
			else
			{
				liberties.Add(border.Elements[i]);
			}
		}
	}
  
	return liberties;
}

//private
Igo.prototype.private_GetLibertiesAllied = function(x, y, numberMin){  

	var liberties = new Chain();  

	var border = this.private_BitBoardAllied.GetBorder(x, y);

	for (var i = 0; i < border.Elements.length; i++)
	{		
		if(this.private_BitBoardLiberties.Fields[border.Elements[i].X][border.Elements[i].Y] == true)
		{
			if(liberties.Elements.length == numberMin)
			{
				break;
			}
			else
			{
				liberties.Add(border.Elements[i]);
			}
		}
	}

	return liberties;
}

//private
Igo.prototype.private_GetPrisoners = function(x, y){  

	//initialize
	var prisoners = new Array();
	this.private_BitBoardAllied = new BitBoard(this.Board.Size);
	this.private_BitBoardOpponents = new BitBoard(this.Board.Size);
	this.private_BitBoardLiberties = new BitBoard(this.Board.Size);

	//set
	this.private_BitBoardAllied = this.Players[this.GetCurrentPlayerId()].BitBoard;

	for (var i = 0; i < this.Players.length; i++)
	{
		if(this.Players[i].Id != this.GetCurrentPlayerId())
		{
			this.private_BitBoardOpponents.Or(this.Players[i].BitBoard);
		}
	}
 
	this.private_BitBoardLiberties.Or(this.private_BitBoardAllied);
	this.private_BitBoardLiberties.Or(this.private_BitBoardOpponents);
	this.private_BitBoardLiberties.Not();

	//check if opponent chains can be captured
	//go to north
	if(this.Board.Size > (y + 1) && this.private_BitBoardOpponents.Fields[x][y + 1] == true)
	{
		var libertiesOpponents = this.private_GetLibertiesOpponents(x, y + 1, 2); 

		if(libertiesOpponents.Elements.length == 1)
		{   
			var chain = this.private_BitBoardOpponents.GetChain(x, y + 1);
			for(var i = 0; i < chain.Elements.length; i++)
			{
				for(var j = 0; j < this.Players.length; j++)
				{
					if(this.Players[j].BitBoard.Fields[chain.Elements[i].X][chain.Elements[i].Y] == true)
					{
						var prisoner = new Prisoner();
						prisoner.X = chain.Elements[i].X;
						prisoner.Y = chain.Elements[i].Y;
						prisoner.PlayerId = parseInt(this.Players[j].Id);
						prisoners[prisoners.length] = prisoner;      
					}
				}
			}
		}
	}
   
	//go to east
	if(this.Board.Size > (x + 1) && this.private_BitBoardOpponents.Fields[x + 1][y] == true)
	{
		var libertiesOpponents = this.private_GetLibertiesOpponents(x + 1, y, 2); 

		if(libertiesOpponents.Elements.length == 1)
		{ 
			var chain = this.private_BitBoardOpponents.GetChain(x + 1, y);
			for(var i = 0; i < chain.Elements.length; i++)
			{
				for(var j = 0; j < this.Players.length; j++)
				{
					if(this.Players[j].BitBoard.Fields[chain.Elements[i].X][chain.Elements[i].Y] == true)
					{
						var prisoner = new Prisoner();
						prisoner.X = chain.Elements[i].X;
						prisoner.Y = chain.Elements[i].Y;
						prisoner.PlayerId = parseInt(this.Players[j].Id);
						prisoners[prisoners.length] = prisoner;    
					}
				}
			}
		}
	}
   
	//go to south
	if(0 <= (y - 1) && this.private_BitBoardOpponents.Fields[x][y - 1] == true)
	{
		var libertiesOpponents = this.private_GetLibertiesOpponents(x, y - 1, 2); 

		if(libertiesOpponents.Elements.length == 1)
		{   
			var chain = this.private_BitBoardOpponents.GetChain(x, y - 1);
			for(var i = 0; i < chain.Elements.length; i++)
			{
				for(var j = 0; j < this.Players.length; j++)
				{
					if(this.Players[j].BitBoard.Fields[chain.Elements[i].X][chain.Elements[i].Y] == true)
					{
						var prisoner = new Prisoner();
						prisoner.X = chain.Elements[i].X;
						prisoner.Y = chain.Elements[i].Y;
						prisoner.PlayerId = parseInt(this.Players[j].Id);
						prisoners[prisoners.length] = prisoner;      
					}
				}
			}
		}
	}
   
	//go to west
	if(0 <= (x - 1) && this.private_BitBoardOpponents.Fields[x - 1][y] == true)
	{
		var libertiesOpponents = this.private_GetLibertiesOpponents(x - 1, y, 2); 

		if(libertiesOpponents.Elements.length == 1)
		{   
			var chain = this.private_BitBoardOpponents.GetChain(x - 1, y);
			for(var i = 0; i < chain.Elements.length; i++)
			{
				for(var j = 0; j < this.Players.length; j++)
				{
					if(this.Players[j].BitBoard.Fields[chain.Elements[i].X][chain.Elements[i].Y] == true)
					{
						var prisoner = new Prisoner();
						prisoner.X = chain.Elements[i].X;
						prisoner.Y = chain.Elements[i].Y;
						prisoner.PlayerId = parseInt(this.Players[j].Id);
						prisoners[prisoners.length] = prisoner;      
					}
				}
			}
		}
	} 

	return prisoners;
}

//private
Igo.prototype.private_GetPlayerIdByPosition = function(x, y){  
	
	var playerId = -1;
	
	for(var i = 0; i < this.Players.length; i++)
	{
		if(this.Players[i].BitBoard.GetValue(x, y) == true)
		{
			playerId = i;
			break;
		}
	}
	
	return playerId;
}

//private
Igo.prototype.private_GetChain = function(x, y, playerIdOfPrisoners){  
	
	return this.Players[playerIdOfPrisoners].BitBoard.GetChain(x, y);
}

//public
Igo.prototype.Capture = function(x, y){  
	
	var playerIdOfPrisoners = this.private_GetPlayerIdByPosition(x, y);	
	
	if(playerIdOfPrisoners > -1)
	{
		var playerIdOpponent = -1;
		
		for(var i = 0; i < this.Players.length; i++)
		{
			if(this.Players[i].Id != playerIdOfPrisoners)
			{
				playerIdOpponent = i;
				break;
			}
		}
		
		if(playerIdOpponent > -1)
		{
			var prisoners = this.private_GetChain(x, y, playerIdOfPrisoners);
			
			this.Players[playerIdOfPrisoners].BitBoard.SetValues(prisoners, false);	
			this.Players[playerIdOpponent].Prisoners += prisoners.Elements.length;
			
			for(var i = 0; i < prisoners.Elements.length; i++)
			{
				var prisoner = new Prisoner();
				prisoner.PlayerId = playerIdOfPrisoners;
				prisoner.X = prisoners.Elements[i].X;
				prisoner.Y = prisoners.Elements[i].Y;
				
				this.CurrentMove.Prisoners[this.CurrentMove.Prisoners.length] = prisoner;
			}
		}
	}
}

//public
Igo.prototype.IsOneMoreMoveAllowed = function(){  
	
	var isOneMoreMoveAllowed = true;
	
	if(this.CurrentMove != null && this.CurrentMove.Type == "capitulation")
	{
		isOneMoreMoveAllowed = false;
	}
	else if(this.CurrentMove != null && this.CurrentMove.Type == "pass" && this.CurrentMove.Parent != null && this.CurrentMove.Parent.Type == "pass" && this.CurrentMove.Parent.Parent != null && this.CurrentMove.Parent.Parent.Type == "pass")
	{
		isOneMoreMoveAllowed = false;
	}
	
	return isOneMoreMoveAllowed;
}