/*
GoFans Client Copyright (C) 2010 Robert Grning (GoFans)
This program comes with ABSOLUTELY NO WARRANTY.
This is free software, and you are welcome to redistribute it under certain conditions. 
<http://www.gnu.org/licenses/>
*/
//class
function ControlGoban(){
 
 this.divGoban = document.getElementById("divGoban");
 
 this.IsTerritoryShown = false;
}

//public
ControlGoban.prototype.Hide = function(){
 
 this.divGoban.style.display = "none";
}

//public
ControlGoban.prototype.Show = function(){
 
 this.divGoban.style.display = "";
}

//public
ControlGoban.prototype.ClearBoard = function(){

 this.divGoban.innerHTML = "";   
}

//public
ControlGoban.prototype.DrawBoard = function () {

    this.ClearBoard();

    this.private_DrawLayer("Board");
    this.private_DrawLayer("Field");
    this.private_DrawLayer("Stone");
    this.private_DrawLayer("Marker");
}

//private
ControlGoban.prototype.private_GetFieldKeyWord = function(x, y, size) {
    var fieldKeyWord;
    var indexMax = (size - 1);
    var indexHalf = ((size - 1) / 2);
    var indexMin = 0;
    
    if (y == indexMin) {
        if (x == indexMin) {
            fieldKeyWord = "CornerLeftTop";
        }
        else if (x == indexMax) {
            fieldKeyWord = "CornerRightTop";
        }
        else {
            fieldKeyWord = "BorderTop";
        }
    }
    else if (y == indexHalf) {
        if (x == indexMin) {
            fieldKeyWord = "BorderLeft";
        }
        else if (x == indexHalf) {
            fieldKeyWord = "CenterHoshi";
        }
        else if (x == indexMax) {
            fieldKeyWord = "BorderRight";
        }
        else {
            fieldKeyWord = "Center";
        }
    }
    else if (y == indexMax) {
        if (x == indexMin) {
            fieldKeyWord = "CornerLeftBottom";
        }
        else if (x == indexMax) {
            fieldKeyWord = "CornerRightBottom";
        }
        else {
            fieldKeyWord = "BorderBottom";
        }
    }
    else {
        if (x == indexMin) {
            fieldKeyWord = "BorderLeft";
        }
        else if (x == indexMax) {
            fieldKeyWord = "BorderRight";
        }
        else {
            fieldKeyWord = "Center";
        }
    }

    if (size == 9) {

        if ((y == 2 || y == indexHalf || y == 6) && (x == 2 || x == indexHalf || x == 6)) {
            fieldKeyWord = "CenterHoshi";
        }
    }
    else if (size == 13) {

        if ((y == 3 || y == indexHalf || y == 9) && (x == 3 || x == indexHalf || x == 9)) {
            fieldKeyWord = "CenterHoshi";
        }
    }
    else 
    {
        if ((y == 3 || y == indexHalf || y == 15) && (x == 3 || x == indexHalf || x == 15)) {
            fieldKeyWord = "CenterHoshi";
        }
    } 

    return fieldKeyWord;
}

//private
ControlGoban.prototype.private_DrawLayer = function(name){

	var size = _pageGoban.Game.Board.Size;  
	var indexMax = (size - 1);
	var indexHalf = ((size - 1) / 2);
	var indexMin = 0;
	var fieldKeyWord = "";
	var fieldSize = this.private_GetFieldSize(size);

	var divTable = document.createElement("div");
	divTable.setAttribute("id", "divLayer" + name);
	divTable.setAttribute("class", "Table Layer"+name);
	divTable.setAttribute("className", "Table Layer"+name);

	if(name == "Board")
	{
		var divRow = document.createElement("div");
		divRow.setAttribute("class", "TableRow");  
		divRow.setAttribute("className", "TableRow"); 
		
		var divCell = document.createElement("div");
		divCell.setAttribute("class", "TableCell");
		divCell.setAttribute("className", "TableCell");
		
		var img = document.createElement("img"); 
		img.setAttribute("id", "img"+name); 
		img.setAttribute("src", _pageGoban.DesignerHandler.GetCurrentDesign().Path+"Background.png");
		img.style.height = (fieldSize * size)+"px";
		img.style.width = (fieldSize * size)+"px";
		
		divCell.style.height = (fieldSize * size)+"px";
		divCell.style.width = (fieldSize * size)+"px";
		divCell.appendChild(img);   
		divRow.appendChild(divCell);
		
		divRow.style.height = (fieldSize * size)+"px";
		divRow.style.width = (fieldSize * size)+"px";
		divTable.appendChild(divRow);
	}
	else
	{
		for (var y = 0; y < size; y++)
		{
			var divRow = document.createElement("div");
			divRow.setAttribute("class", "TableRow");  
			divRow.setAttribute("className", "TableRow"); 

			for (var x = 0; x < size; x++)
			{
				var divCell = document.createElement("div");
				divCell.setAttribute("class", "TableCell");
				divCell.setAttribute("className", "TableCell");

				var img = document.createElement("img"); 
				img.setAttribute("id", "img"+name+"_"+x+"_"+(size - y - 1));   

				if(name == "Field")
				{ 
					fieldKeyWord = this.private_GetFieldKeyWord(x, y, size);
					img.setAttribute("src", _pageGoban.DesignerHandler.GetCurrentDesign().Path + fieldKeyWord + ".png");
				}
				else if(name == "Stone")
				{
					img.setAttribute("src", _pageGoban.DesignerHandler.GetCurrentDesign().Path+"Empty.png"); 
				}
				else if(name == "Marker")
				{
					img.setAttribute("src", _pageGoban.DesignerHandler.GetCurrentDesign().Path+"Empty.png"); 
					img.setAttribute("title", "("+(x + 1)+":"+(size - y)+")"); 
					img.onclick = new Function("_pageGoban.controlGoban.img"+name+"_OnClick("+x+","+(size - y - 1)+")");
				}
				img.style.height = fieldSize+"px";
				img.style.width = fieldSize+"px";
				divCell.style.height = fieldSize+"px";
				divCell.style.width = fieldSize+"px";
				divCell.appendChild(img);   
				divRow.appendChild(divCell);
			}

			divRow.style.height = fieldSize+"px";
			divRow.style.width = (fieldSize * size)+"px";
			divTable.appendChild(divRow);
		}
	}

	divTable.style.height = (fieldSize * size)+"px";
	divTable.style.width = (fieldSize * size)+"px";
	this.divGoban.appendChild(divTable);
}

//private
ControlGoban.prototype.private_GetFieldSize = function(size) {
    var fieldSize;
    if (size == 9) {
        fieldSize = 35;
    }
    else if (size == 13) {
        fieldSize = 27;
    }
    else {
        fieldSize = 19;
    }
    return fieldSize;
}

//public
ControlGoban.prototype.RefreshBoardDesign = function(){

 this.private_RefreshLayerDesign("Field");
 this.private_RefreshLayerDesign("Stone"); 
 this.private_RefreshLayerDesign("Marker"); 
 
 document.getElementById("divLayerField").style.background = "url('"+_pageGoban.DesignerHandler.GetCurrentDesign().Path+"Background.png') no-repeat";
}

//private
ControlGoban.prototype.private_RefreshLayerDesign = function(name){

 var size = _pageGoban.Game.Board.Size;  
 var fieldKeyWord = "";
 var fieldSize = this.private_GetFieldSize(size);
 
 for (var y = 0; y < size; y++)
 {  
  for (var x = 0; x < size; x++)
  {   
   var img = document.getElementById("img"+name+"_"+x+"_"+(size - y - 1));     
      
   if(name == "Stone")
   {
    for (var i = 0; i < _pageGoban.Game.Players.length; i++)
    {
	 if(_pageGoban.Game.Players[i].BitBoard.GetValue(x, size - y - 1) == true)
	 {	 
      		img.src = _pageGoban.DesignerHandler.GetCurrentDesign().Path+"Stoneff"+_pageGoban.Game.Players[i].Color+".png";
	  	break;
	 }
    }
   }
   else
   {
    var startIndex = img.src.lastIndexOf("/") + 1;	
    img.src = _pageGoban.DesignerHandler.GetCurrentDesign().Path + img.src.substr(startIndex, img.src.length - startIndex);
   }	
  }
 }
}

//public
ControlGoban.prototype.GoToPrevious = function(){

	if(_pageGoban.Game.CurrentMove != null)
	{ 
		if(_pageGoban.Game.CurrentMove.Type == "positioning")
		{
			var imgStone = document.getElementById("imgStone_"+_pageGoban.Game.CurrentMove.X+"_"+_pageGoban.Game.CurrentMove.Y);
			imgStone.src = _pageGoban.DesignerHandler.GetCurrentDesign().Path+"Empty.png";  
			var imgMarker = document.getElementById("imgMarker_"+_pageGoban.Game.CurrentMove.X+"_"+_pageGoban.Game.CurrentMove.Y);
			imgMarker.src = _pageGoban.DesignerHandler.GetCurrentDesign().Path+"Empty.png";  
			
			this.DrawPrisoners(_pageGoban.Game.CurrentMove.Prisoners); 
		}
		else if(_pageGoban.Game.CurrentMove.Type == "pass")
		{
			this.DrawPrisoners(_pageGoban.Game.CurrentMove.Prisoners); 
		}
	} 

	_pageGoban.controlConsole.Write(_pageGoban.TextHandler.GetText(_pageGoban.Game.GoToPrevious()));
	_pageGoban.controlInformation.SetPoints();
	_pageGoban.controlInformation.MarkCurrentPlayer();

	if(_pageGoban.Game.CurrentMove != null)
	{
		if(_pageGoban.Game.CurrentMove.Type == "positioning")
		{
			var imgMarker = document.getElementById("imgMarker_"+_pageGoban.Game.CurrentMove.X+"_"+_pageGoban.Game.CurrentMove.Y);
			imgMarker.src = _pageGoban.DesignerHandler.GetCurrentDesign().Path+"MarkerLast.png";  
		}
	}
}

//public
ControlGoban.prototype.GoToCleanBoard = function(){

	_pageGoban.controlConsole.Write(_pageGoban.TextHandler.GetText(_pageGoban.Game.GoToCleanBoard()));
	_pageGoban.controlInformation.SetPoints();
	_pageGoban.controlInformation.MarkCurrentPlayer();

	for(var x = 0; x < _pageGoban.Game.Board.Size; x++)
	{
		for(var y = 0; y < _pageGoban.Game.Board.Size; y++)
		{
			var imgStone = document.getElementById("imgStone_"+x+"_"+y);
			imgStone.src = _pageGoban.DesignerHandler.GetCurrentDesign().Path+"Empty.png";
			var imgMarker = document.getElementById("imgMarker_"+x+"_"+y);
			imgMarker.src = _pageGoban.DesignerHandler.GetCurrentDesign().Path+"Empty.png";
		}
	} 
}

//public
ControlGoban.prototype.GoToNext = function(childIndex){

	var message = _pageGoban.Game.GoToNext(childIndex);
	
	_pageGoban.controlConsole.Write(_pageGoban.TextHandler.GetText(message));
	_pageGoban.controlInformation.SetPoints();
	_pageGoban.controlInformation.MarkCurrentPlayer();

	if(_pageGoban.Game.CurrentMove != null && _pageGoban.Game.CurrentMove.Parent != null && _pageGoban.Game.CurrentMove.Parent.Type == "positioning")
	{   
		var imgMarker = document.getElementById("imgMarker_"+_pageGoban.Game.CurrentMove.Parent.X+"_"+_pageGoban.Game.CurrentMove.Parent.Y);
		imgMarker.src = _pageGoban.DesignerHandler.GetCurrentDesign().Path+"Empty.png";  
	}  

	if(_pageGoban.Game.CurrentMove.Type == "positioning")
	{
		var imgStone = document.getElementById("imgStone_"+_pageGoban.Game.CurrentMove.X+"_"+_pageGoban.Game.CurrentMove.Y);
		imgStone.src = _pageGoban.DesignerHandler.GetCurrentDesign().Path+"Stoneff"+_pageGoban.Game.Players[_pageGoban.Game.CurrentMove.PlayerId].Color+".png";
		var imgMarker = document.getElementById("imgMarker_"+_pageGoban.Game.CurrentMove.X+"_"+_pageGoban.Game.CurrentMove.Y);
		imgMarker.src = _pageGoban.DesignerHandler.GetCurrentDesign().Path+"MarkerLast.png";  
		
		this.RemovePrisoners(_pageGoban.Game.CurrentMove.Prisoners);
	}
	else if(_pageGoban.Game.CurrentMove.Type == "pass")
	{
		this.RemovePrisoners(_pageGoban.Game.CurrentMove.Prisoners);
		
		if(_pageGoban.Game.IsOneMoreMoveAllowed() == false)
		{
			this.DrawTerritory();
		}
	}	
	
	return message;
}

//public
ControlGoban.prototype.GoToLast = function(){

	var message = 400;

	while(message != 209)
	{
		message = _pageGoban.Game.GoToNext(0);
	}

	for(var x = 0; x < _pageGoban.Game.Board.Size; x++)
	{
		for(var y = 0; y < _pageGoban.Game.Board.Size; y++)
		{ 			
			var imgMarker = document.getElementById("imgMarker_"+x+"_"+y);
			imgMarker.src = _pageGoban.DesignerHandler.GetCurrentDesign().Path+"Empty.png";
			
			var imgStone = document.getElementById("imgStone_"+x+"_"+y);
			imgStone.src = _pageGoban.DesignerHandler.GetCurrentDesign().Path+"Empty.png";

			for(var i = 0; i < _pageGoban.Game.Players.length; i++)
			{
				if(_pageGoban.Game.Players[i].BitBoard.GetValue(x, y) == true)
				{
					var imgStone = document.getElementById("imgStone_"+x+"_"+y);
					imgStone.src = _pageGoban.DesignerHandler.GetCurrentDesign().Path+"Stoneff"+_pageGoban.Game.Players[i].Color+".png";
					break;
				}   
			}
		}
	} 

	if(_pageGoban.Game.CurrentMove.Type == "positioning")
	{
		var imgStone = document.getElementById("imgStone_"+_pageGoban.Game.CurrentMove.X+"_"+_pageGoban.Game.CurrentMove.Y);
		imgStone.src = _pageGoban.DesignerHandler.GetCurrentDesign().Path+"Stoneff"+_pageGoban.Game.Players[_pageGoban.Game.CurrentMove.PlayerId].Color+".png";
		var imgMarker = document.getElementById("imgMarker_"+_pageGoban.Game.CurrentMove.X+"_"+_pageGoban.Game.CurrentMove.Y);
		imgMarker.src = _pageGoban.DesignerHandler.GetCurrentDesign().Path+"MarkerLast.png";
	}
	
	this.DrawTerritory();

	_pageGoban.controlConsole.Write(_pageGoban.TextHandler.GetText(message));
	_pageGoban.controlInformation.SetPoints();
	_pageGoban.controlInformation.MarkCurrentPlayer();

	return message;
}

//public
ControlGoban.prototype.DrawTerritory = function(){

	for(var i = 0; i < _pageGoban.Game.Players.length; i++)
	{
		var territory = _pageGoban.Game.GetTerritory(_pageGoban.Game.Players[i].Id);
		for(var j = 0; j < territory.Elements.length; j++)
		{
			document.getElementById("img"+"Marker"+"_"+territory.Elements[j].X+"_"+territory.Elements[j].Y).src = _pageGoban.DesignerHandler.GetCurrentDesign().Path+"Marker96"+_pageGoban.Game.Players[i].Color+".png";
		}
		_pageGoban.Game.Players[i].Territory = territory.Elements.length;		
	}	
	
	this.IsTerritoryShown = true;
	
	_pageGoban.controlInformation.SetPoints();
}

//public
ControlGoban.prototype.ClearTerritory = function(){

	this.ClearLayer("Marker");
	
	this.IsTerritoryShown = false;
}

//public
ControlGoban.prototype.ClearLayer = function(name){

	for(var x = 0; x < _pageGoban.Game.Board.Size; x++)
	{
		for(var y = 0; y < _pageGoban.Game.Board.Size; y++)
		{ 
			var imgMarker = document.getElementById("img"+name+"_"+x+"_"+y);
			imgMarker.src = _pageGoban.DesignerHandler.GetCurrentDesign().Path+"Empty.png";
		}
	}
}

//public
ControlGoban.prototype.Pass = function(){

	//no alternative kifu
	if((_pageGoban.Game.CurrentMove == null && _pageGoban.Game.Moves.length == 0) || (_pageGoban.Game.CurrentMove != null && (_pageGoban.Game.CurrentMove.Type == "positioning" || _pageGoban.Game.CurrentMove.Type == "pass") && _pageGoban.Game.CurrentMove.Moves.length == 0))
	{	 
		_pageGoban.controlConsole.Write(_pageGoban.TextHandler.GetText(_pageGoban.Game.Pass()));	
		_pageGoban.controlGoban.GoToNext(0);	
		_pageGoban.controlInformation.MarkCurrentPlayer();
	}
	else
	{
		if(_pageGoban.Game.CurrentMove == null || (_pageGoban.Game.CurrentMove != null && _pageGoban.Game.CurrentMove.Type != "capitulation"))
		{	
			var dialogResult = confirm(_pageGoban.TextHandler.GetText(600));
			
			if(dialogResult == true)
			{
				if(_pageGoban.Game.CurrentMove == null)
				{
					_pageGoban.Game.Moves = new Array();
				}
				else
				{
					_pageGoban.Game.CurrentMove.Moves = new Array();
				}
				
				_pageGoban.controlConsole.Write(_pageGoban.TextHandler.GetText(_pageGoban.Game.Pass()));	
				_pageGoban.controlGoban.GoToNext(0);	
				_pageGoban.controlInformation.MarkCurrentPlayer();
			}
		}
	}
}

//public
ControlGoban.prototype.Capitulate = function(){

	//no alternative kifu
	if((_pageGoban.Game.CurrentMove == null && _pageGoban.Game.Moves.length == 0) || (_pageGoban.Game.CurrentMove != null && (_pageGoban.Game.CurrentMove.Type == "positioning" || _pageGoban.Game.CurrentMove.Type == "pass") && _pageGoban.Game.CurrentMove.Moves.length == 0))
	{	 
		_pageGoban.controlConsole.Write(_pageGoban.TextHandler.GetText(_pageGoban.Game.Capitulate()));	
		_pageGoban.controlGoban.GoToNext(0);	
		_pageGoban.controlInformation.MarkCurrentPlayer();
	}
	else
	{
		if(_pageGoban.Game.CurrentMove == null || (_pageGoban.Game.CurrentMove != null && _pageGoban.Game.CurrentMove.Type != "capitulation"))
		{		
			var dialogResult = confirm(_pageGoban.TextHandler.GetText(600));
			
			if(dialogResult == true)
			{
				if(_pageGoban.Game.CurrentMove == null)
				{
					_pageGoban.Game.Moves = new Array();
				}
				else
				{
					_pageGoban.Game.CurrentMove.Moves = new Array();
				}
				
				_pageGoban.controlConsole.Write(_pageGoban.TextHandler.GetText(_pageGoban.Game.Capitulate()));	
				_pageGoban.controlGoban.GoToNext(0);	
				_pageGoban.controlInformation.MarkCurrentPlayer();
			}
		}
	}
}

//event
ControlGoban.prototype.imgMarker_OnClick = function(x, y){

	//no alternative kifu
	if((_pageGoban.Game.CurrentMove == null && _pageGoban.Game.Moves.length == 0) || (_pageGoban.Game.CurrentMove != null && (_pageGoban.Game.CurrentMove.Type == "positioning" || _pageGoban.Game.CurrentMove.Type == "pass") && _pageGoban.Game.CurrentMove.Moves.length == 0))
	{	 
		_pageGoban.controlConsole.Write(_pageGoban.TextHandler.GetText(_pageGoban.Game.Position(x, y)));
		_pageGoban.controlGoban.GoToNext(0);
	}
	else
	{
		if(_pageGoban.Game.CurrentMove == null || (_pageGoban.Game.CurrentMove != null && _pageGoban.Game.CurrentMove.Type != "capitulation"))
		{
			var dialogResult = confirm(_pageGoban.TextHandler.GetText(600));
			
			if(dialogResult == true)
			{
				if(_pageGoban.Game.CurrentMove == null)
				{
					_pageGoban.Game.Moves = new Array();
				}
				else
				{
					_pageGoban.Game.CurrentMove.Moves = new Array();
				}
				
				_pageGoban.controlConsole.Write(_pageGoban.TextHandler.GetText(_pageGoban.Game.Position(x, y)));
				_pageGoban.controlGoban.GoToNext(0);
			}
		}
	}
	
	if(_pageGoban.Game.IsOneMoreMoveAllowed() == false)
	{
		_pageGoban.Game.Capture(x, y);
		this.RemovePrisoners(_pageGoban.Game.CurrentMove.Prisoners);
		this.ClearTerritory();
		this.DrawTerritory();
	}
}

//public
ControlGoban.prototype.RemovePrisoners = function(prisoners){

	for (var i = 0; i < prisoners.length; i++)
	{ 
		var imgStone = document.getElementById("imgStone_"+prisoners[i].X+"_"+prisoners[i].Y);
		imgStone.src = _pageGoban.DesignerHandler.GetCurrentDesign().Path+"Empty.png";
	}
}

//public
ControlGoban.prototype.DrawPrisoners = function(prisoners){

	for (var i = 0; i < prisoners.length; i++)
	{ 
		var imgStone = document.getElementById("imgStone_"+prisoners[i].X+"_"+prisoners[i].Y);
		imgStone.src = _pageGoban.DesignerHandler.GetCurrentDesign().Path+"Stoneff"+_pageGoban.Game.Players[prisoners[i].PlayerId].Color+".png";
	} 
}