/*
GoFans Client Copyright (C) 2010 Robert Grning (GoFans)
This program comes with ABSOLUTELY NO WARRANTY.
This is free software, and you are welcome to redistribute it under certain conditions. 
<http://www.gnu.org/licenses/>
*/
//class
function ControlInformation() {
  
	this.divInformation = document.getElementById("divInformation");
}

//public
ControlInformation.prototype.Hide = function(){
 
	this.divInformation.style.display = "none";
}

//public
ControlInformation.prototype.Show = function(){
 
	this.divInformation.style.display = "";
}

//public
ControlInformation.prototype.Clear = function (text) {

    this.divInformation.innerHTML = "";
}

//public
ControlInformation.prototype.SetTexts = function () {

	this.Clear();

	if(_pageGoban.Game != null)
	{
		var divInformationGame = document.createElement("div");
		divInformationGame.appendChild(this.private_CreateElementInformationGame());
		divInformation.appendChild(divInformationGame);		
		this.private_SetTextsGame();

		var divInformationPlayers = document.createElement("div");
		divInformationPlayers.appendChild(this.private_CreateElementInformationPlayers());
		divInformation.appendChild(divInformationPlayers);		
		this.private_SetTextsPlayers();
	}
}

//private
ControlInformation.prototype.private_SetTextsGame = function () {
	
	document.getElementById("labelRule").innerHTML = _pageGoban.TextHandler.GetText("rule") + ":";
	document.getElementById("labelRuleValue").innerHTML = _pageGoban.TextHandler.GetText(_pageGoban.Game.Rule.Name);
	document.getElementById("labelServer").innerHTML = _pageGoban.TextHandler.GetText("server") + ":";
	document.getElementById("labelServerValue").innerHTML = _pageGoban.Game.Server;
	document.getElementById("labelDate").innerHTML = _pageGoban.TextHandler.GetText("date") + ":";
	document.getElementById("labelDateValue").innerHTML = _pageGoban.Game.Date.toLocaleString();
	document.getElementById("labelComputationType").innerHTML = _pageGoban.TextHandler.GetText("computationsystem") + ":";
	document.getElementById("labelComputationTypeValue").innerHTML = _pageGoban.TextHandler.GetText(_pageGoban.Game.Computation.Type);
	document.getElementById("labelKomi").innerHTML = _pageGoban.TextHandler.GetText("komi") + ":";
	document.getElementById("labelKomiValue").innerHTML = _pageGoban.Game.Players[1].Komi.toString().replace(".", _pageGoban.TextHandler.GetText("."));
	document.getElementById("labelHandicap").innerHTML = _pageGoban.TextHandler.GetText("handicap") + ":";
	document.getElementById("labelHandicapValue").innerHTML = _pageGoban.Game.Players[0].Handicap;
}

//private
ControlInformation.prototype.private_SetTextsPlayers = function () {
	
	for(var i = 0; i < _pageGoban.Game.Players.length; i++)
	{
		document.getElementById("labelPlayer"+i+"Color").innerHTML = _pageGoban.TextHandler.GetText("color") + ":";
		document.getElementById("labelPlayer"+i+"Name").innerHTML = _pageGoban.TextHandler.GetText("name") + ":";
		document.getElementById("labelPlayer"+i+"NameValue").innerHTML = _pageGoban.Game.Players[i].Name;
		document.getElementById("labelPlayer"+i+"Strength").innerHTML = _pageGoban.TextHandler.GetText("strength") + ":";
		document.getElementById("labelPlayer"+i+"StrengthValue").innerHTML = _pageGoban.Game.Players[i].Strength + _pageGoban.Game.Players[i].StrengthClass;
		document.getElementById("labelPlayer"+i+"Points").innerHTML = _pageGoban.TextHandler.GetText("points") + ":";
	}

	this.SetColors();
	this.SetPoints();
}

//public
ControlInformation.prototype.SetColors = function () {

	for (var i = 0; i < _pageGoban.Game.Players.length; i++)
	{
		//1st the six digit long hexadecimal color value
		var color = _pageGoban.Game.Players[i].Color;

		if (_pageGoban.DesignerHandler.CurrentDesignerIndex > -1 && _pageGoban.DesignerHandler.CurrentDesignIndex > -1)
		{
			//2nd the name of the stone design
			color = _pageGoban.DesignerHandler.GetCurrentDesign().GetStone(color).Name;
			var text = _pageGoban.TextHandler.GetText(color);
			if(text != "")
			{
				//3rd the translated name of the stone design
				color = text;
			}
			
		}

		document.getElementById("labelPlayer" + i + "ColorValue").innerHTML = color;
	}
}

//public
ControlInformation.prototype.SetPoints = function () {

    for (var i = 0; i < _pageGoban.Game.Players.length; i++) {

        document.getElementById("labelPlayer" + i + "PointsValue").innerHTML = _pageGoban.Game.Players[i].GetPoints().toString().replace(".", _pageGoban.TextHandler.GetText("."));
    }
}

//public
ControlInformation.prototype.MarkCurrentPlayer = function () {

    for (var i = 0; i < _pageGoban.Game.Players.length; i++)
	{
        document.getElementById("divPlayer" + i).style.color = "#000000";
    }
	
    document.getElementById("divPlayer" + _pageGoban.Game.GetCurrentPlayerId()).style.color = "#A17021";    
}

//private
ControlInformation.prototype.private_CreateElementInformationGame = function () {
	
	var divTable = document.createElement("div");
	divTable.setAttribute("class", "Table");
	divTable.setAttribute("className", "Table");

	divTable.appendChild(this.private_CreateElementRow("Rule"));
	divTable.appendChild(this.private_CreateElementRow("Server"));
	divTable.appendChild(this.private_CreateElementRow("Date"));
	divTable.appendChild(this.private_CreateElementRow("ComputationType"));
	divTable.appendChild(this.private_CreateElementRow("Komi"));	
	divTable.appendChild(this.private_CreateElementRow("Handicap"));	

	return divTable;
}

//private
ControlInformation.prototype.private_CreateElementInformationPlayers = function () {

	var divTable = document.createElement("div");
	divTable.setAttribute("class", "Table");
	divTable.setAttribute("className", "Table");

	var divTableRow = document.createElement("div");
	divTableRow.setAttribute("class", "TableRow");
	divTableRow.setAttribute("className", "TableRow");

	for(var i = 0; i < _pageGoban.Game.Players.length; i++)
	{
		var divTableCell = document.createElement("div");
		divTableCell.setAttribute("class", "TableCell");
		divTableCell.setAttribute("className", "TableCell");
		
		divTableCell.appendChild(this.private_CreateElementInformationPlayer(i));
		divTableRow.appendChild(divTableCell);
	}

	divTable.appendChild(divTableRow);

	return divTable;
}

//private
ControlInformation.prototype.private_CreateElementInformationPlayer = function (index) {

	var divTable = document.createElement("div");
	divTable.setAttribute("id", "divPlayer"+index);
	divTable.setAttribute("class", "Table");
	divTable.setAttribute("className", "Table");

	divTable.appendChild(this.private_CreateElementRow("Player"+index+"Color"));
	divTable.appendChild(this.private_CreateElementRow("Player"+index+"Name"));
	divTable.appendChild(this.private_CreateElementRow("Player"+index+"Strength"));
	divTable.appendChild(this.private_CreateElementRow("Player"+index+"Points"));

	return divTable;
}

//private
ControlInformation.prototype.private_CreateElementRow = function (name) {
			
	var divTableRow = document.createElement("div");
	divTableRow.setAttribute("class", "TableRow");
	divTableRow.setAttribute("className", "TableRow");

	divTableRow.appendChild(this.private_CreateElementCell(name));
	divTableRow.appendChild(this.private_CreateElementCell(name+"Value"));

	return divTableRow;	
}

//private
ControlInformation.prototype.private_CreateElementCell = function (name) {
			
	var divTableCell = document.createElement("div");
	divTableCell.setAttribute("class", "TableCell");
	divTableCell.setAttribute("className", "TableCell");

	var label = document.createElement("label");
	label.setAttribute("id", "label" + name);

	divTableCell.appendChild(label);

	return divTableCell;	
}
