/*
GoFans Client Copyright (C) 2010 Robert Grning (GoFans)
This program comes with ABSOLUTELY NO WARRANTY.
This is free software, and you are welcome to redistribute it under certain conditions. 
<http://www.gnu.org/licenses/>
*/
//class
function ControlNew(){
 
 this.divNew = document.getElementById("divNew");

 this.labelNewRule = document.getElementById("labelNewRule");
 this.selectNewRule = document.getElementById("selectNewRule");

 this.labelNewSize = document.getElementById("labelNewSize");
 this.selectNewSize = document.getElementById("selectNewSize");

 this.labelNewDesign = document.getElementById("labelNewDesign");
 this.selectNewDesign = document.getElementById("selectNewDesign");

 this.labelNewComputationType = document.getElementById("labelNewComputationType");
 this.selectNewComputationType = document.getElementById("selectNewComputationType");

 this.labelNewKomi = document.getElementById("labelNewKomi");
 this.textboxNewKomi = document.getElementById("textboxNewKomi");

 this.labelNewHandicap = document.getElementById("labelNewHandicap");
 this.textboxNewHandicap = document.getElementById("textboxNewHandicap");

 this.labelNewPlayer = document.getElementById("labelNewPlayer");
 this.buttonNewPlayerPrevious = document.getElementById("buttonNewPlayerPrevious");
 this.labelNewPlayerPager = document.getElementById("labelNewPlayerPager");
 this.buttonNewPlayerNext = document.getElementById("buttonNewPlayerNext");
 this.labelNewPlayerColor = document.getElementById("labelNewPlayerColor");
 this.selectNewPlayerColor = document.getElementById("selectNewPlayerColor");
 this.labelNewPlayerName = document.getElementById("labelNewPlayerName");
 this.textboxNewPlayerName = document.getElementById("textboxNewPlayerName");
 this.labelNewPlayerStrength = document.getElementById("labelNewPlayerStrength");
 this.selectNewPlayerStrength = document.getElementById("selectNewPlayerStrength");

 this.buttonCreate = document.getElementById("buttonCreate");

 this.rules = new Array("igo", "iroirogote");  
 this.sizes = new Array(9,13,19); 
 this.computationTypes = new Array("chinese","japanese"); 

 this.IsShown = true;
 
 //private
 //axilary variables
 this.game = null;
 this.currentPlayerIndex = 0;
}

//public
ControlNew.prototype.SetTexts = function(){
 
 this.labelNewRule.innerHTML = _pageGoban.TextHandler.GetText("rule");
 this.labelNewSize.innerHTML = _pageGoban.TextHandler.GetText("size");
 this.labelNewDesign.innerHTML = _pageGoban.TextHandler.GetText("design");
 this.labelNewComputationType.innerHTML = _pageGoban.TextHandler.GetText("computationsystem");
 this.labelNewKomi.innerHTML = _pageGoban.TextHandler.GetText("komi");
 this.labelNewHandicap.innerHTML = _pageGoban.TextHandler.GetText("handicap");
 this.labelNewPlayer.innerHTML = _pageGoban.TextHandler.GetText("players");
 this.labelNewPlayerColor.innerHTML = _pageGoban.TextHandler.GetText("color");
 this.labelNewPlayerName.innerHTML = _pageGoban.TextHandler.GetText("name");
 this.labelNewPlayerStrength.innerHTML = _pageGoban.TextHandler.GetText("strength");
 this.buttonCreate.value = _pageGoban.TextHandler.GetText("create");
  
 this.private_LoadSelectNewRule();

 document.getElementById("buttonNewPlayerPrevious").style.background = "#EAEAEA url(Images/ButtonToPrevious_Enabled.png) no-repeat center center";
 document.getElementById("buttonNewPlayerNext").style.background = "#EAEAEA url(Images/ButtonToNext_Enabled.png) no-repeat center center";
}

//public
ControlNew.prototype.Hide = function(){
 
 this.divNew.style.display = "none";
 this.IsShown = false;
}

//public
ControlNew.prototype.Show = function(){
 
 this.divNew.style.display = "";
 this.IsShown = true;
}

//public
ControlNew.prototype.Disable = function(disable){
 
 this.selectNewRule.disabled = disable;
 this.selectNewSize.disabled = disable;
 this.DisableSelectNewDesign(disable);
 this.selectNewComputationType.disabled = disable;
 this.textboxNewKomi.disabled = disable;
 this.textboxNewHandicap.disabled = disable;
 this.buttonNewPlayerPrevious.disabled = disable;
 this.buttonNewPlayerNext.disabled = disable;
 this.selectNewPlayerColor.disabled = disable;
 this.textboxNewPlayerName.disabled = disable;
 this.selectNewPlayerStrength.disabled = disable;
 this.buttonCreate.disabled = disable;
}

//public
ControlNew.prototype.DisableSelectNewDesign = function (disable) {

    this.selectNewDesign.disabled = disable;
}

//private
ControlNew.prototype.private_LoadSelectNewRule = function(){
 
	this.selectNewRule.innerHTML = "";

	for(var i = 0; i < this.rules.length; i++)
	{
		var option = document.createElement("option");
		option.setAttribute("value", this.rules[i]);
		option.appendChild(document.createTextNode(_pageGoban.TextHandler.GetText(this.rules[i])));
		this.selectNewRule.appendChild(option);
	}

	//default: standard
	this.selectNewRule[0].selected = true;
	this.private_SetRule();
}

//private
ControlNew.prototype.private_SetRule = function(){
 
	this.currentPlayerIndex = 0;
	
	if(this.selectNewRule.value == "igo")
	{
		this.game = new Igo();
		
		var player = new Player();
		player.Id = 0;
		player.Handicap = 1;
		player.Color = "000000";
		this.game.Players[this.game.Players.length] = player;
		
		player = new Player();
		player.Id = 1;
		player.Color = "ffffff";
		this.game.Players[this.game.Players.length] = player;
	}
	else if(this.selectNewRule.value == "iroirogote")
	{
		this.game = new IroIroGote();
		
		var player = new Player();
		player.Id = 0;
		player.Handicap = 1;
		player.Color = "000000";
		this.game.Players[this.game.Players.length] = player;
				
		player = new Player();
		player.Id = 1;
		player.Color = "000000";
		this.game.Players[this.game.Players.length] = player;
	}

	this.game.Computation = new Computation();
	this.game.Server = "localhost";
	this.private_LoadSelectNewSize();
	this.private_LoadSelectNewDesign();
	this.private_LoadSelectNewComputationType();
}

//event
ControlNew.prototype.selectNewRule_onChange = function()
{
	this.private_SetRule();
}

//private
ControlNew.prototype.private_LoadSelectNewSize = function(){

	this.selectNewSize.innerHTML = "";

	for(var i = 0; i < this.sizes.length; i++)
	{
		var option = document.createElement("option");
		option.setAttribute("value", this.sizes[i]);
		option.appendChild(document.createTextNode(this.sizes[i]));
		this.selectNewSize.appendChild(option);
	}

	//default: 19
	this.selectNewSize[2].selected = true;
	this.private_SetSize();
}

//private
ControlNew.prototype.private_SetSize = function(){
 
	this.game.Board = new Board();
	this.game.Board.Size = parseInt(this.selectNewSize.value);

	for(var i = 0; i < this.game.Players.length; i++)
	{
		this.game.Players[i].BitBoard = new BitBoard(this.game.Board.Size);
	}
}

//event
ControlNew.prototype.selectNewSize_onChange = function()
{
	this.private_SetSize();
	this.private_SetHandicap();
}

//private
ControlNew.prototype.private_LoadSelectNewDesign = function(){

    this.selectNewDesign.innerHTML = "";
    var standardIndex = 0;
    var isStandardFound = false;

    for (var i = 0; i < _pageGoban.DesignerHandler.Designers.length; i++) {
        var optgroup = document.createElement("optgroup");
        optgroup.setAttribute("label", _pageGoban.DesignerHandler.Designers[i].Name);

        for (var j = 0; j < _pageGoban.DesignerHandler.Designers[i].Designs.length; j++) {

		    var option = document.createElement("option");
		    option.setAttribute("value", i + ";" + j);
		    option.appendChild(document.createTextNode(_pageGoban.DesignerHandler.Designers[i].Designs[j].Name));
		    optgroup.appendChild(option);

		    if (_pageGoban.DesignerHandler.Designers[i].Name == "GoFans" && _pageGoban.DesignerHandler.Designers[i].Designs[j].Name == "Standard") {
		        isStandardFound = true;
		    }

		    if (isStandardFound == false) {
		        standardIndex++;
		    }
        }
        if (optgroup.childNodes.length > 0) {
            this.selectNewDesign.appendChild(optgroup);
        }
    }

    if (isStandardFound == true) {
        this.selectNewDesign.selectedIndex = standardIndex;
    }
    else {
        this.selectNewDesign.selectedIndex = 0;
    }
    this.private_SetDesign();
}

//event
ControlNew.prototype.selectNewDesign_onChange = function()
{
	this.private_SetDesign();
}

//private
ControlNew.prototype.private_SetDesign = function()
{
 
	var pattern = /^([\d]+);([\d]+)$/;
	_pageGoban.DesignerHandler.SetCurrentDesign(this.selectNewDesign.value.match(pattern)[1], this.selectNewDesign.value.match(pattern)[2]);

	this.private_LoadSelectNewComputationType();
	this.private_LoadTextboxNewKomi();
	this.private_LoadTextboxNewHandicap();
	this.private_LoadLabelNewPlayerPager();
	this.private_LoadSelectNewPlayerColor();
	this.private_LoadTextboxNewPlayerName();
	this.private_LoadSelectNewPlayerStrength();
}

//private
ControlNew.prototype.private_LoadSelectNewComputationType = function(){
 
 this.selectNewComputationType.innerHTML = "";

 for(var i = 0; i < this.computationTypes.length; i++)
 {
  var option = document.createElement("option");
  option.setAttribute("value", this.computationTypes[i]);
  option.appendChild(document.createTextNode(_pageGoban.TextHandler.GetText(this.computationTypes[i])));
  this.selectNewComputationType.appendChild(option);
 }

 //default: japanese
 this.selectNewComputationType[1].selected = true;
 this.private_SetComputationType();
}

//event
ControlNew.prototype.selectNewComputationType_onChange = function()
{
	this.private_SetComputationType();
}

//private
ControlNew.prototype.private_SetComputationType = function(){
 
 this.game.Computation.Type = this.selectNewComputationType.value;
}

//private
ControlNew.prototype.private_LoadTextboxNewKomi = function(){
 
	//default: 6.5
	this.textboxNewKomi.value = "6.5".replace(".", _pageGoban.TextHandler.GetText("."));
	this.private_SetKomi();
}

//event
ControlNew.prototype.textboxNewKomi_onChange = function()
{
	var pattern = /^[\d]+[\.,][50]$/;

	if(pattern.test(this.textboxNewKomi.value) == true)
	{
		this.private_SetKomi();
	}
	else
	{
		this.private_LoadTextboxNewKomi();
	}
}

//private
ControlNew.prototype.private_SetKomi = function(){
 
	this.game.Computation.Komi = parseFloat(this.textboxNewKomi.value.replace(",", "."));
	this.game.Players[1].Komi = this.game.Computation.Komi;
}

//private
ControlNew.prototype.private_LoadTextboxNewHandicap = function(){
 
	//default: 6.5
	this.textboxNewHandicap.value = "1";
	this.private_SetHandicap();
}

//event
ControlNew.prototype.textboxNewHandicap_onChange = function()
{
	var pattern = /^[1-9]$/;

	if(pattern.test(this.textboxNewHandicap.value) == true)
	{
		this.private_SetHandicap();
	}
	else
	{
		this.private_LoadTextboxNewHandicap();
	}
}

//private
ControlNew.prototype.private_SetHandicap = function(){
 
	this.game.Players[0].Handicap = parseInt(this.textboxNewHandicap.value);
}

//private
ControlNew.prototype.private_LoadLabelNewPlayerPager = function(){

 this.labelNewPlayerPager.innerHTML = (this.currentPlayerIndex + 1) + "/" + this.game.Players.length;
}

//private
ControlNew.prototype.private_LoadTextboxNewPlayerName = function(){

 this.textboxNewPlayerName.value = this.game.Players[this.currentPlayerIndex].Name;
 this.private_SetName();
}

//event
ControlNew.prototype.textboxNewPlayerName_onChange = function(){

 this.private_SetName();
}

//private
ControlNew.prototype.private_SetName = function(){

 this.game.Players[this.currentPlayerIndex].Name = this.textboxNewPlayerName.value;
}

//private
ControlNew.prototype.private_LoadSelectNewPlayerColor = function(){

	this.selectNewPlayerColor.innerHTML = "";
	var selectedColorIndex = 0;

	for(var i = 0; i < _pageGoban.DesignerHandler.GetCurrentDesign().Stones.length; i++)
	{
		var color = _pageGoban.TextHandler.GetText(_pageGoban.DesignerHandler.GetCurrentDesign().Stones[i].Name);

		if (color == "")
		{ 
			color = _pageGoban.DesignerHandler.GetCurrentDesign().Stones[i].Name;
		}
		var option = document.createElement("option");
		option.setAttribute("value", _pageGoban.DesignerHandler.GetCurrentDesign().Stones[i].Color);
		option.appendChild(document.createTextNode(color));
		this.selectNewPlayerColor.appendChild(option);

		if(_pageGoban.DesignerHandler.GetCurrentDesign().Stones[i].Color == this.game.Players[this.currentPlayerIndex].Color)
		{
			selectedColorIndex = i;
		}
	}

	if(this.game.Rule.Name == "igo")
	{
		this.selectNewPlayerColor.disabled = true;
	}
	else
	{	
		this.selectNewPlayerColor.disabled = false;
	}
	
	this.selectNewPlayerColor[selectedColorIndex].selected = true;

	this.private_SetColor();
}

//event
ControlNew.prototype.textboxNewPlayerColor_onChange = function(){

 this.private_SetColor();
}

//private
ControlNew.prototype.private_SetColor = function(){

	if(this.game.Rule.Name == "igo")
	{
		this.game.Players[this.currentPlayerIndex].Color = this.selectNewPlayerColor.value;
	}
	else if(this.game.Rule.Name == "iroirogote")
	{
		for(var i = 0; i < this.game.Players.length; i++)
		{
			this.game.Players[i].Color = this.selectNewPlayerColor.value;
		}
	}
}

//private
ControlNew.prototype.private_LoadSelectNewPlayerStrength = function(){

 this.selectNewPlayerStrength.innerHTML = "";

 var optgroup = document.createElement("optgroup");
 optgroup.setAttribute("label", _pageGoban.TextHandler.GetText("kyu"));

 for(var i = 35; i > 0; i--)
 {
  this.currentPlayerIndex
  var option = document.createElement("option");
  option.setAttribute("value", i + "kyu");
  option.appendChild(document.createTextNode(i + _pageGoban.TextHandler.GetText("kyu")));
  optgroup.appendChild(option);
 }

 this.selectNewPlayerStrength.appendChild(optgroup);

 optgroup = document.createElement("optgroup");
 optgroup.setAttribute("label", _pageGoban.TextHandler.GetText("dan"));

 for(var i = 1; i <= 9; i++)
 {
  var option = document.createElement("option");
  option.setAttribute("value", i + "dan");
  option.appendChild(document.createTextNode(i + _pageGoban.TextHandler.GetText("dan")));
  optgroup.appendChild(option);
 }

 this.selectNewPlayerStrength.appendChild(optgroup);

 if(this.game.Players[this.currentPlayerIndex].StrengthClass == "kyu")
 {
  this.selectNewPlayerStrength[35 - this.game.Players[this.currentPlayerIndex].Strength].selected = true;
 }
 else
 {
  this.selectNewPlayerStrength[35 + 9 - this.game.Players[this.currentPlayerIndex].Strength].selected = true;
 }
 this.private_SetPlayerStrength();
}

//event
ControlNew.prototype.selectNewPlayerStrength_onChange = function()
{
 this.private_SetPlayerStrength();
}

//private
ControlNew.prototype.private_SetPlayerStrength = function(){

 var pattern = /^([\d]+)([\w]+)$/;
 
 this.game.Players[this.currentPlayerIndex].Strength = this.selectNewPlayerStrength.value.match(pattern)[1];
 this.game.Players[this.currentPlayerIndex].StrengthClass = this.selectNewPlayerStrength.value.match(pattern)[2];
}

//event
ControlNew.prototype.buttonNewPlayerPrevious_OnClick = function()
{
 if(this.currentPlayerIndex > 0)
 {
  this.currentPlayerIndex--;
 }

 this.private_LoadLabelNewPlayerPager();
 this.private_LoadSelectNewPlayerColor();
 this.private_LoadTextboxNewPlayerName();
 this.private_LoadSelectNewPlayerStrength();
}

//event
ControlNew.prototype.buttonNewPlayerNext_OnClick = function()
{
 if(this.currentPlayerIndex < (this.game.Players.length - 1))
 {
  this.currentPlayerIndex++;
 }

 this.private_LoadLabelNewPlayerPager();
 this.private_LoadSelectNewPlayerColor();
 this.private_LoadTextboxNewPlayerName();
 this.private_LoadSelectNewPlayerStrength();
}

//event
ControlNew.prototype.buttonCreate_onClick = function()
{
	this.game.Server = "localhost";

	if(this.private_IsGameValid() == true)
	{
		this.game.SetDefaultHandicap();
		while(this.game.GoToPrevious() != 208)
		{}
 
		_pageGoban.controlMenu.controlNew.Hide();
		_pageGoban.LoadGame(this.game);
	}
	else
	{
		_pageGoban.controlConsole.Write(_pageGoban.TextHandler.GetText(411));
	}
}

//private
ControlNew.prototype.private_IsGameValid = function(){
  
 var isGameValid = false;
 var playerNames = new Array();

 var arePlayersValid = true;
 for(var i = 0; i < this.game.Players.length; i++)
 {
  var isInList = false;
  
  for (var j = 0; j < playerNames.length; j++)
  {
   if(playerNames[j] == this.game.Players[i].Name)
   {
    isInList = true;
    break;
   }
  }

  arePlayersValid = arePlayersValid && (this.game.Players[i].Name != "") && (!isInList);

  if(arePlayersValid == true)
  {
   playerNames[playerNames.length] = this.game.Players[i].Name; 
  }
  else
  {
   break;
  }
 }
 isGameValid = arePlayersValid;
 
 return isGameValid;
}