/*
GoFans Client Copyright (C) 2010 Robert Grning (GoFans)
This program comes with ABSOLUTELY NO WARRANTY.
This is free software, and you are welcome to redistribute it under certain conditions. 
<http://www.gnu.org/licenses/>
*/
//class
function ControlPlayer(){
 
	this.divPlayer = document.getElementById("divPlayer");
	this.buttonPlay = document.getElementById("buttonPlay");
	this.buttonPause = document.getElementById("buttonPause");
	this.buttonToCleanBoard = document.getElementById("buttonToCleanBoard");
	this.buttonToPrevious = document.getElementById("buttonToPrevious");
	this.buttonToNext = document.getElementById("buttonToNext");
	this.buttonToLast = document.getElementById("buttonToLast");
	this.buttonPass = document.getElementById("buttonPass");
	this.buttonCapitulate = document.getElementById("buttonCapitulate");
	this.buttonTerritory = document.getElementById("buttonTerritory");
}

//public
ControlPlayer.prototype.SetTexts = function(){ 
 
	this.buttonToCleanBoard.title = _pageGoban.TextHandler.GetText("emptyboard");
	this.buttonToPrevious.title = _pageGoban.TextHandler.GetText("back");
	this.buttonToNext.title = _pageGoban.TextHandler.GetText("next");
	this.buttonToLast.title = _pageGoban.TextHandler.GetText("laststone");
	this.buttonPlay.title = _pageGoban.TextHandler.GetText("play");
	this.buttonPause.title = _pageGoban.TextHandler.GetText("pause");
	this.buttonPass.value = _pageGoban.TextHandler.GetText("pass");
	this.buttonCapitulate.value = _pageGoban.TextHandler.GetText("capitulate");
	this.buttonTerritory.value = _pageGoban.TextHandler.GetText("territory");
}

//public
ControlPlayer.prototype.Enable = function () {

    this.private_Disable(false);
}

//public
ControlPlayer.prototype.Disable = function () {

    this.private_Disable(true);
}

//private
ControlPlayer.prototype.private_Disable = function (disable) {

	this.DisableBackward(disable);
	this.DisableForward(disable);
	this.buttonPass.disabled = disable;
	this.buttonCapitulate.disabled = disable;
	this.buttonTerritory.disabled = disable;
}

//public
ControlPlayer.prototype.DisableForward = function (disable) {

    var keyword = "Enabled";

    if (disable == true) {
        keyword = "Disabled";
    }

    this.DisableAutoPlay(disable);

    this.buttonToNext.style.background = "#EAEAEA url(Images/ButtonToNext_" + keyword + ".png) no-repeat center center";
    this.buttonToNext.disabled = disable;
    this.buttonToLast.style.background = "#EAEAEA url(Images/ButtonToLast_" + keyword + ".png) no-repeat center center";
    this.buttonToLast.disabled = disable;
}

//public
ControlPlayer.prototype.DisableAutoPlay = function (disable) {

    this.DisableButtonPlay(disable);
    this.DisableButtonPause(disable);
}

//public
ControlPlayer.prototype.DisableButtonPlay = function (disable) {

    var keyword = "Enabled";

    if (disable == true) {
        keyword = "Disabled";
    }

    this.buttonPlay.style.background = "#EAEAEA url(Images/ButtonPlay_" + keyword + ".png) no-repeat center center";
    this.buttonPlay.disabled = disable;
}

//public
ControlPlayer.prototype.DisableButtonPause = function (disable) {

    var keyword = "Enabled";

    if (disable == true) {
        keyword = "Disabled";
    }

    this.buttonPause.style.background = "#EAEAEA url(Images/ButtonPause_" + keyword + ".png) no-repeat center center";
    this.buttonPause.disabled = disable;
}

//public
ControlPlayer.prototype.DisableManualPlay = function (disable) {

    var keyword = "Enabled";

    if (disable == true) {
        keyword = "Disabled";
    }

    this.buttonToCleanBoard.style.background = "#EAEAEA url(Images/ButtonToCleanBoard_" + keyword + ".png) no-repeat center center";
    this.buttonToCleanBoard.disabled = disable;
    this.buttonToPrevious.style.background = "#EAEAEA url(Images/ButtonToPrevious_" + keyword + ".png) no-repeat center center";
    this.buttonToPrevious.disabled = disable;
    this.buttonToNext.style.background = "#EAEAEA url(Images/ButtonToNext_" + keyword + ".png) no-repeat center center";
    this.buttonToNext.disabled = disable;
    this.buttonToLast.style.background = "#EAEAEA url(Images/ButtonToLast_" + keyword + ".png) no-repeat center center";
    this.buttonToLast.disabled = disable;
}

//public
ControlPlayer.prototype.DisableBackward = function (disable) {

    var keyword = "Enabled";

    if (disable == true) {
        keyword = "Disabled";
    }

    this.buttonToCleanBoard.style.background = "#EAEAEA url(Images/ButtonToCleanBoard_" + keyword + ".png) no-repeat center center";
    this.buttonToCleanBoard.disabled = disable;
    this.buttonToPrevious.style.background = "#EAEAEA url(Images/ButtonToPrevious_" + keyword + ".png) no-repeat center center";
    this.buttonToPrevious.disabled = disable;
}

//public
ControlPlayer.prototype.Hide = function(){
 
 this.divPlayer.style.display = "none";
}

//public
ControlPlayer.prototype.Show = function(){
 
 this.divPlayer.style.display = "";
}

var isPlaying = false;

//event
ControlPlayer.prototype.buttonPlay_OnClick = function(){

 isPlaying = true;
 _pageGoban.controlPlayer.DisableManualPlay(true);
 _pageGoban.controlPlayer.DisableButtonPause(false);
 _pageGoban.controlPlayer.DisableButtonPlay(true);
 _pageGoban.controlPlayer.Play();
}

//public
ControlPlayer.prototype.Play = function(){

 var message = _pageGoban.controlGoban.GoToNext(0); 
 
 if(message != 209 && message < 400 && isPlaying == true)
 {
  setTimeout("_pageGoban.controlPlayer.Play()", 800);
 }
 else
 {  
  isPlaying = false;
  _pageGoban.controlPlayer.DisableManualPlay(false);
  _pageGoban.controlPlayer.DisableButtonPause(true);
  _pageGoban.controlPlayer.DisableButtonPlay(false);
 }
}

//event
ControlPlayer.prototype.buttonPause_OnClick = function(){
 
 isPlaying = false;
}

//event
ControlPlayer.prototype.buttonToCleanBoard_OnClick = function(){
  
	if(_pageGoban.controlGoban.IsTerritoryShown == true)
	{
		_pageGoban.controlGoban.ClearTerritory();
	}
	_pageGoban.controlGoban.GoToCleanBoard();
}

//event
ControlPlayer.prototype.buttonToPrevious_OnClick = function(){

	if(_pageGoban.controlGoban.IsTerritoryShown == true)
	{
		_pageGoban.controlGoban.ClearTerritory();
	}
	_pageGoban.controlGoban.GoToPrevious();
}

//event
ControlPlayer.prototype.buttonToNext_OnClick = function(){

	if(_pageGoban.controlGoban.IsTerritoryShown == true)
	{
		_pageGoban.controlGoban.ClearTerritory();
	}
	_pageGoban.controlGoban.GoToNext(0);
}

//event
ControlPlayer.prototype.buttonToLast_OnClick = function(){
 
	if(_pageGoban.controlGoban.IsTerritoryShown == true)
	{
		_pageGoban.controlGoban.ClearTerritory();
	}
	_pageGoban.controlGoban.GoToLast();
}

//event
ControlPlayer.prototype.buttonPass_OnClick = function(){
 
 _pageGoban.controlGoban.Pass();
}

//event
ControlPlayer.prototype.buttonCapitulate_OnClick = function(){
 
 _pageGoban.controlGoban.Capitulate();
}

//event
ControlPlayer.prototype.buttonTerritory_OnClick = function(){
 
	_pageGoban.controlGoban.DrawTerritory();
}