/*
GoFans Client Copyright (C) 2010 Robert Grning (GoFans)
This program comes with ABSOLUTELY NO WARRANTY.
This is free software, and you are welcome to redistribute it under certain conditions. 
<http://www.gnu.org/licenses/>
*/
//class
function PageGoban(){

	//public properties
	this.Game = null;
	this.TextHandler = null;
	this.DesignHandler = null;
   
	//initialize controls
	this.controlMenu = new ControlMenu();
	this.controlMenu.controlNew.Hide();
	this.controlMenu.controlLoad.Hide();
	this.controlMenu.controlSave.Hide();
	this.controlConsole = new ControlConsole();
	this.controlInformation = new ControlInformation();
	this.controlEditor = new ControlEditor(); 
	this.controlGoban = new ControlGoban();
	this.controlPlayer = new ControlPlayer();
	this.controlComments = new ControlComments();
	this.controlKifu = new ControlKifu();
}

//public
PageGoban.prototype.Load = function(){

	//loads and imports designers
	this.private_LoadDesignHandler();
}

//public
PageGoban.prototype.private_LoadDesignHandler = function(){

	var filePath = "Images/Designers.xml";
 
	if (window.ActiveXObject)
	{
		_xmlDesigners = new ActiveXObject('Microsoft.XMLDOM');
		_xmlDesigners.async = "false";
		_xmlDesigners.onreadystatechange = this.private_ImportDesigners;
		_xmlDesigners.load(filePath);  
	}
	else
	{
		_xmlDesigners = document.implementation.createDocument("","",null);
		_xmlDesigners.load(filePath);
		_xmlDesigners.onload = this.private_ImportDesigners;
	} 
}

//event
PageGoban.prototype.private_ImportDesigners = function(){

	if(_xmlDesigners.readyState == 4 /*IE*/ || _xmlDesigners.readyState == "complete" /*FF, Opera, ...*/)
	{
		var designerImporter = new DesignerImporter();
		_pageGoban.DesignerHandler = designerImporter.Import(_xmlDesigners);
		  
		_pageGoban.private_LoadTextHandler();
	}
}

//public
PageGoban.prototype.private_LoadTextHandler = function(){
		
	var culture = "";
		
	if(navigator.language)
	{		
		culture = this.private_GetCulture(navigator.language);		
	}
	if(culture == "" && (navigator.browserLanguage))
	{		
		culture = this.private_GetCulture(navigator.browserLanguage);
	}
	if(culture == "" && (navigator.userLanguage))
	{		
		culture = this.private_GetCulture(navigator.userLanguage);
	}
	
	//default is "en-GB"
	if(culture == "")
	{
		culture = "en-GB";
	}
 
	var filePath = "Texts/Texts_"+culture+".xml";
	if (window.ActiveXObject)
	{
		_xmlTexts = new ActiveXObject('Microsoft.XMLDOM');
		_xmlTexts.async = "false";
		_xmlTexts.onreadystatechange = this.private_ImportTexts;
		_xmlTexts.load(filePath);  
	}
	else
	{
		_xmlTexts = document.implementation.createDocument("","",null);
		_xmlTexts.load(filePath);
		_xmlTexts.onload = this.private_ImportTexts;
	} 
}

//private
PageGoban.prototype.private_GetCulture = function(language){

	var culture = "";
	
	if(language.indexOf("de") == 0)
	{
		culture = "de-DE";
	}
	else if(language.indexOf("en") == 0)
	{
		culture = "en-GB";
	}
	else if(language.indexOf("eo") == 0)
	{
		culture = "eo";
	}
	else if(language.indexOf("es") == 0)
	{
		culture = "es-ES";
	}
	else if(language.indexOf("et") == 0)
	{
		culture = "et-EE";
	}
	else if(language.indexOf("jp") == 0)
	{
		culture = "jp-JP";
	}
	else if(language.indexOf("ro") == 0)
	{
		culture = "ro-RO";
	}
	else if(language.indexOf("ru") == 0)
	{
		culture = "ru-RU";
	}
	else if(language.indexOf("zh") == 0)
	{
		culture = "zh-CN";
	}
	
	return culture;
}

//event
PageGoban.prototype.private_ImportTexts = function(){

	if(_xmlTexts.readyState == 4 /*IE*/ || _xmlTexts.readyState == "complete" /*FF, Opera, ...*/)
	{
		var textImporter = new TextImporter();
		_pageGoban.TextHandler = textImporter.Import(_xmlTexts);
  
		_pageGoban.controlMenu.SetTexts(); 
		_pageGoban.LoadGame(null);
		_pageGoban.controlConsole.Write(_pageGoban.TextHandler.GetText(210));
	}
}

//public
PageGoban.prototype.LoadGame = function(game){

	this.Game = game;

	if(this.Game == null)
	{
		this.controlInformation.Clear();

		this.controlEditor.SetTexts();
		this.controlEditor.Disable();

		this.controlPlayer.SetTexts();
		this.controlPlayer.Disable();

		this.controlGoban.ClearBoard();

		//this.controlComments.Clear();
		//this.controlComments.Disable();
	}
	else
	{
		this.controlInformation.SetTexts();

		this.controlEditor.SetTexts();
		this.controlEditor.Enable();

		this.controlPlayer.SetTexts();
		this.controlPlayer.Enable();

		this.controlGoban.DrawBoard();
		
		for(var i = 0; i < this.Game.Players[0].Handicap; i++)
		{
			this.controlGoban.GoToNext(0);
		}
		
		//this.controlComments.SetTexts();
		//this.controlComments.Enable();
	}
}

function textButton_OnMouseOver(elementId){

 document.getElementById(elementId).style.textDecoration = "underline";
}

function textButton_OnMouseOut(elementId){

 document.getElementById(elementId).style.textDecoration = "none";
}
