/*
GoFans Client Copyright (C) 2010 Robert Grning (GoFans)
This program comes with ABSOLUTELY NO WARRANTY.
This is free software, and you are welcome to redistribute it under certain conditions. 
<http://www.gnu.org/licenses/>
*/
//class
function TextImporter(){
 
}
 
//public
TextImporter.prototype.Import = function(xml){

 var textHandler = this.private_GetTextHandler(xml);
 
 return textHandler;
}
 
//private
TextImporter.prototype.private_ReadNode = function(node, name){
 
 var childNode = null;
 
 if(this.private_ReadNodes(node, name).length > 0)
 {
  childNode = this.private_ReadNodes(node, name)[0];
 }
 
 return childNode;
}
 
//private
TextImporter.prototype.private_ReadNodes = function(node, name){
 
 var childNodes = new Array();
 
 for (var i  = 0; i < node.childNodes.length; i++)
 {
  if(node.childNodes[i].tagName == name)  
  {
   childNodes[childNodes.length] = node.childNodes[i];
  }
 }
  
 return childNodes;
}

//private
TextImporter.prototype.private_GetTextHandler = function(node){
 
 var textHandler = new TextHandler();
 
 var nodeTexts = this.private_ReadNode(node, "texts"); 
 var nodesText = this.private_ReadNodes(nodeTexts, "text"); 
 
 for (var i = 0; i < nodesText.length; i++)
 {
  textHandler.AddText(this.private_ReadText(nodeTexts, i));
 }
 
 return textHandler;
}

//private
TextImporter.prototype.private_ReadText = function(node, index){
 
 var text = null;
 
 if(this.private_ReadNodes(node, "text") != null)
 {
  text = new Text();
  var nodeText = this.private_ReadNodes(node, "text")[index];
  text.Id = nodeText.attributes.getNamedItem("id").value;
  if(nodeText.text != null && nodeText.text != "" && nodeText.text != undefined)
  {
   text.Text = nodeText.text;
  }
  else
  {
   text.Text = nodeText.textContent;
  }
 }
 
 return text;
}
